<?php
/**
 * Plugin Name: WC-Google-Sheets-Sync
 * Plugin URI: http://wc-google-sheets-sync.com
 * Description: Sync Products to Google Sheets through Sheets API
 * Version: 1.93
 * Author: Devi Sakthi
 * Author URI: http://deesbliss.com
 * Text Domain: wcgss
 **/
if (! defined('ABSPATH')) {
    die;
}

define('WCGSS_PATH', untrailingslashit(plugin_dir_path(__FILE__)));
require ABSPATH . 'wp-content/plugins/wc-google-sheets-sync-pro/admin/settings_initiate.php';

function wcgss_menu()
{
    //wp_enqueue_style( 'syncprod.css', get_stylesheet_uri() );
    add_menu_page('WC Google Spreadsheets Sync Pro', 'WC Google Spreadsheets Sync Pro', 'manage_options', 'wcgss-settings', 'wcgss_settings');
    add_submenu_page('wcgss-sync', 'Settings Title', 'Settings', 'manage_options', 'wcgss-sync', 'wcgss_func');
    add_submenu_page('wcgss-settings', 'Logs', 'Logs', 'manage_options', 'wcgss-logs', 'wc_logs');
    add_action('admin_init', 'register_wcgss_settings');
}
add_action('admin_menu', 'wcgss_menu');

function wcgss_load_css_and_js()
{
    wp_enqueue_style('wcgss_style', plugins_url('wcgss_style.css', __FILE__));
    wp_enqueue_script('wcgss_script', plugins_url('/admin/js/wcgss_script.js', __FILE__));
    wp_enqueue_style('datatables_bootstrap', plugins_url('/admin/css/bootstrap.min.css', __FILE__));
    wp_enqueue_script('datatables', plugins_url('/admin/js/jquery.dataTables.min.js', __FILE__));
    wp_enqueue_script('datatables_bootstrap', plugins_url('/admin/js/dataTables.bootstrap.min.js', __FILE__));
    wp_enqueue_style('datatables_style', plugins_url('/admin/js/dataTables.bootstrap.min.css', __FILE__));    
    /*
    wp_enqueue_script('datatables', 'https://cdn.datatables.net/1.10.13/js/jquery.dataTables.min.js', array('jquery'), true);
  wp_enqueue_script('datatables_bootstrap', 'https://cdn.datatables.net/1.10.13/js/dataTables.bootstrap.min.js', array('jquery'), true);
  wp_enqueue_style('bootstrap_style', 'https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css');
  wp_enqueue_style('datatables_style', 'https://cdn.datatables.net/1.10.13/css/dataTables.bootstrap.min.css');
     */

  wp_localize_script('wcgss_script', 'google_ajax_object', array( 'ajax_url' => admin_url('admin-ajax.php') ));
    wp_enqueue_script( 'wc_logs_datatables', plugins_url('/admin/js/wc_logstable.js', __FILE__));
  wp_localize_script( 'wc_logs_datatables', 'wcgss_ajax_url', array( 'ajax_url' => admin_url('admin-ajax.php?action=wc_logs_datatables') ));
}
add_action('admin_enqueue_scripts', 'wcgss_load_css_and_js');

function installer()
{
    global $table_prefix;
    global $wpdb;
    $wp_log_table = $table_prefix .'wcgss_logs';
    $sql = "CREATE TABLE `". $wp_log_table . "` ( ";
    $sql .= "  `id`  int(11)   NOT NULL auto_increment, ";
    $sql .= "  `module`  varchar(255)   NOT NULL, ";
    $sql .= "  `response` text NOT NULL, ";
    $sql .= "   `date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP, ";    
    $sql .= "   PRIMARY KEY (`id`) ";
    $sql .= ") ENGINE=InnoDB DEFAULT CHARSET=utf8mb4; ";

    if ($wpdb->get_var("show tables like ".$wp_log_table."") != $wp_log_table) {
        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
        dbDelta($sql);
    }
}
register_activation_hook(__file__, 'installer');
