<?php
require_once plugin_dir_path(__FILE__) . '../includes/zohoAuth.php';
require_once plugin_dir_path(__FILE__) . '../includes/api_layer.php';
$zoho_auth = new zoho_auth();
$generate_refersh_token = $zoho_auth->getAccessToken();
$api = new Api_Layer();

?>
<h2>Get Products from ZOHO Books</h2>

<form method='POST' action="">
  <input type="submit" name="submit" class="button" value="Synz Products to Zoho" id="get_product">
</form>

<style type="text/css">
  .product_sync{
    display: grid;
    grid-template-columns: auto auto auto auto;
    grid-gap: 10px;
    padding: 20px;
  }
  .product_sync label{
    padding: 5px;
    width: 150px;
  }
  .product_sync input{
    width: 300px;
    height: 20px;
  }
  #get_product{
    width: 30%;
    display: block;
    margin-left: auto;
    margin-right: auto;
  }
</style>

<?php

if(isset($_POST['submit'])){
                global $wpdb;
	$wp_option_find = $wpdb->get_results("SELECT * FROM wp_options where (option_name='woo_zoho_fields_map1')");
    if ($wp_option_find){
      $mapping_fields = $wp_option_find[0]->option_value;
      $array = json_decode($mapping_fields,JSON_FORCE_OBJECT);
      $filterArray = array_filter($array, function ($var) {
          return (strpos($var, 'Choose') === false);
      });
      $filter = array();
      foreach ($filterArray as $key => $value) {
        $filter[] = $key;
      }
    }

$args = array(
'post_type'      => 'product',
'posts_per_page' => -1
);

$loop = new WP_Query( $args );

while ( $loop->have_posts() ) : $loop->the_post();
global $product;
$productJson = array();
$productId = $product->get_id();
$productJson['name'] = $product->get_name();
$productJson['rate'] = $product->get_price();
$productJson['sku'] = $product->get_sku();
$productJson['description'] = $product->get_description();
$productJsonRequest = json_encode($productJson,TRUE);
$checkItem = $api->checkItemAlreadyExits($product->get_sku(),$generate_refersh_token);
if(count($checkItem['items']) == 0)
{
	$itemsDetail = $api->createZohoItem($productJsonRequest,$generate_refersh_token);	
	$itemsDetail = json_decode($itemsDetail,TRUE);	
	$itemId = $itemsDetail['item']['item_id'];
	update_post_meta( $productId, '_zoho_item_id', $itemId );
}
else
{
	$itemId = $checkItem['items'][0]['item_id'];
	$itemsDetail = $api->updateZohoItem($productJsonRequest,$itemId,$generate_refersh_token);
}
endwhile;
wp_reset_query();
echo "<h2>Products Synzed Suessfully.</h2>";
}

?>
