<?php
require_once plugin_dir_path(dirname(__FILE__)) . 'vendor/autoload.php';
require_once plugin_dir_path(dirname(__FILE__)) . 'admin/event_layer.php';
require_once plugin_dir_path(dirname(__FILE__)) . 'admin/frame_layer.php';
require_once plugin_dir_path(dirname(__FILE__)) . 'admin/api_layer.php';

use \Firebase\JWT\JWT;

function register_wcgss_settings()
{
    register_setting('wcgss_credentials_group', 'credentials');
    register_setting('wcgss_inventory_schedule_group', 'inventory_schedule_chkbox');
    register_setting('wcgss_customer_schedule_group', 'customer_schedule_chkbox');
    register_setting('wcgss_product_schedule_group', 'product_schedule_chkbox');
}

function wcgss_settings()
{
    echo '<div class="wrap">
                <h2>WCGSS Settings Page</h2></div>';

    require ABSPATH . '/wp-content/plugins/wc-google-sheets-sync-pro/admin/templates/wcgss-settings.php';
}

function wcgss_func()
{
    require ABSPATH . '/wp-content/plugins/wc-google-sheets-sync-pro/admin/templates/service-account-help.php';
}

function wc_logs()
{
    require_once plugin_dir_path(__FILE__) . 'templates/logs.php';
}


add_action('wp_ajax_wcgss_ajax_call', 'wcgss_ajax_call');
add_action('wp_ajax_nopriv_wcgss_ajax_call', 'wcgss_ajax_call');
function wcgss_ajax_call()
{
    $api = new Api_Controller();
    $credentials = $_POST['credentials'];
    $credentials = str_replace("\\", "", $credentials);
    $inventory_schedule_chkbox = $_POST['inventory_schedule_chkbox'];
    $inventory_schedule_chkbox = str_replace("\\", "", $inventory_schedule_chkbox);

    $data = array(
        'success' => false,
        'message' => 'Error of while saving',
    );

    $credential = (isset($_POST['credentials']) && !empty($_POST['credentials'])) ? json_decode(stripslashes($_POST['credentials']), true) : false ;
    if ($credential) {
        if (isset($credential['private_key'], $credential['client_email'])) {
            $token = wpgsi_token($credential);
            if ($token[0]) {
                $token[1]['expires_in'] = time() + $token[1]['expires_in'];
                update_option('wcgss_google_credential', $credential);
                update_option('wcgss_google_token', $token[1]);
                $data = array(
            'success' => true,
            'module' => 'credential',
            'message' => "Credentails Saved successfully",
        );
            } else {
                $data = array(
                            'success' => false,
                'module' => 'credential',
                    'message' => "Error :  on token Creation.",
                );
            }
        } else {
            $data = array(
            'success' => false,
            'module' => 'credential',
            'message' => "Error :  on token Creation.",
        );
        }
    }

    if ($_POST['deleteCredential'] == 1) {
        $module = 'credential';
        $deleteCre = '1';
        $deletToken = '1';
        update_option('wcgss_google_credential', $deleteCre);
        update_option('wcgss_google_token', $deletToken);
        update_option('google_product_identifier', '');
        update_option('google_qty', '');
        update_option('google_sheet_id', '');
        update_option('google_order_mapping', '');
        update_option('google_order_sheetid', '');
        update_option('google_customer_mapping', '');
        update_option('google_customer_sheetid', '');
        global $wpdb;
        $table  = $wpdb->prefix . 'wcgss_logs';
        $delete = $wpdb->query("TRUNCATE TABLE $table");
        $data = array(
        'success' => true,
        'module' => 'credential',
        'message' => 'Credential deleted Successfully.',
    );
    }


    if ($_POST['product_identifier'] != '' && $_POST['qty'] != '' && $_POST['google_sheet'] != '') {
        $module = 'inventory';
        $product_identifier = $_POST['product_identifier'];
        $google_qty = $_POST['qty'];
        $google_sheet_id = $_POST['google_sheet'];
        update_option('google_product_identifier', $product_identifier);
        update_option('google_qty', $google_qty);
        update_option('google_sheet_id', $google_sheet_id);
        $data = array(
        'success' => true,
        'module' => 'inventory',
        'message' => 'Google Inventory Mapping Saved Successfully.',
        );
    }

    if ($_POST['google_sheet_order'] != '') {
        $sheeID = $_POST['google_sheet_order'];
        $SpreadsheetID  = sanitize_text_field($sheeID);
        $google_token   = get_option('wcgss_google_token', false);
	$orderResponse   = $api->checkOrderResquest($SpreadsheetID, $google_token);
        update_option('google_order_mapping', $orderResponse);
        update_option('google_order_sheetid', $sheeID);
        $data = array(
        'success' => true,
    'module' => 'order',
        'message' => 'Google order Mapping Saved Successfully.',
    );
    }

    if ($_POST['google_sheet_orderitem'] != '') {
        $sheeID = $_POST['google_sheet_orderitem'];
        $SpreadsheetID  = sanitize_text_field($sheeID);
        $google_token   = get_option('wcgss_google_token', false);
        $orderResponse   = $api->checkOrderResquest($SpreadsheetID, $google_token);
        update_option('google_orderitem_mapping', $orderResponse);
        update_option('google_orderitem_sheetid', $sheeID);
        $data = array(
        'success' => true,
    'module' => 'orderitem',
        'message' => 'Google order item Mapping Saved Successfully.',
    );
    }

    if ($_POST['google_sheet_customer'] != '') {
        $sheeID = $_POST['google_sheet_customer'];
        $SpreadsheetID  = sanitize_text_field($sheeID);
        $google_token   = get_option('wcgss_google_token', false);
        $columnTitle    = wcgss_columnTitle($SpreadsheetID, $google_token);
        $orderArray = array();
        foreach ($columnTitle as $key=>$value) {
            $orderArray[$_POST['woo_customer_attribute'.$key]] = $_POST['sheet_customer_header'.$key];
        }
        $order_json =json_encode($orderArray, true);
        update_option('google_customer_mapping', $order_json);
        update_option('google_customer_sheetid', $sheeID);
        $data = array(
        'success' => true,
    'module' => 'customer',
        'message' => 'Google Customer Mapping Saved Successfully.',
        );
    }
    if ($inventory_schedule_chkbox != '') {
        update_option('inventory_schedule_chkbox', $inventory_schedule_chkbox);
        $data = array(
            'success' => true,
        'module' => 'inventory',
            'message' => 'Inventory Cron Schedulled Successfully.',
            );
    }
    if ($data['module'] != '') {
        global $wpdb;
        $tablename = $wpdb->prefix.'wcgss_logs';
        $wpdb->insert(
            $tablename,
            array(
        'module' => $data['module'],
        'response' => $data['message']),
            array( '%s', '%s' )
        );
    }
    echo wp_send_json($data);
    wp_die();
}


function wpgsi_token($credential = [])
{
    if (! isset($credential['client_email'])) {
        return array( false, array('Error:'=> 420 , 'Message' => 'Error: client_email not set. from  wpgsi_token func !') );
    }
    if (empty($credential['client_email'])) {
        return array( false, array('Error:'=> 420 , 'Message' => "Error: client_email is Empty. from wpgsi_token func !") );
    }
    if (! isset($credential['private_key'])) {
        return array( false, array('Error:'=> 420 , 'Message' => "Error: private_key not set. from  wpgsi_token func !") );
    }
    if (empty($credential['private_key'])) {
        return array( false, array('Error:'=> 420 , 'Message' => "Error: private_key is Empty. from wpgsi_token func !") );
    }

    $payload = array(
        "iss"       =>  $credential['client_email'],
        "scope"     => 'https://www.googleapis.com/auth/drive',
        "aud"       => 'https://oauth2.googleapis.com/token',
        "exp"       =>      time()+3600,
        "iat"       =>      time(),
    );

    $jwt  = JWT::encode($payload, $credential['private_key'], 'RS256');

    $args = array(
        'headers' => array(),
        'body'    => array(
            'grant_type' => 'urn:ietf:params:oauth:grant-type:jwt-bearer',
            'assertion'  => $jwt,
        )
    );

    $returns  =  wp_remote_post('https://oauth2.googleapis.com/token', $args);
    if (is_wp_error($returns) or ! is_array($returns) or ! isset($returns['body'])) {
        return array( false, "Error :  on token Creation." . json_encode($returns, true)  );
    } else {
        return array( true, json_decode($returns['body'], true) );
    }
}

function wcgss_GoogleSpreadsheets()
{
    $credential     = get_option('wcgss_google_credential', false);
    $google_token   = get_option('wcgss_google_token', false);

    if ($google_token  &&  time() > $google_token['expires_in']) {
        if ($credential) {
            $new_token = wpgsi_token($credential);
            if ($new_token[0]) {
                $new_token[1]['expires_in'] = time() + $new_token[1]['expires_in'];
                $google_token = $new_token[1];
                update_option('wcgss_google_token', $new_token[1]);
            }
        }
    }
    if ($google_token) {
        $r =  wcgss_spreadsheetsAndWorksheets($google_token);
        if (isset($r[0]) && $r[0]) {
            return $r;
        } else {
            return array( false, array());
        }
    } else {
        return array( false, array());
    }
}


function wcgss_spreadsheetsAndWorksheets($token = [])
{
    if (! is_array($token)) {
        return array( false, "Error : Token is Not Array. from wpgsi_spreadsheetsAndWorksheets func !"  );
    }
    if (! isset($token['access_token'])) {
        return array( false, "Error : access_token elements are not set on the token Array! from wpgsi_spreadsheetsAndWorksheets func !"  );
    }
    if (empty($token['access_token'])) {
        return array( false, "Error : access_token elements is empty on the token Array! from wpgsi_spreadsheetsAndWorksheets func !"  );
    }
    $returns = wp_remote_get("https://www.googleapis.com/drive/v3/files?access_token=" . $token['access_token']);

    if (is_wp_error($returns)  or  ! isset($returns['response']['code'])  or $returns['response']['code'] != 200) {
        return array( false, json_encode($returns) );
    }
    $body                                   = json_decode($returns['body'], true);
    $files                                  = $body['files'];
    $spreadsheets                   = array();
    $spreadsheetsWorksheet  = array();

    foreach ($files  as $file) {
        if ($file['mimeType'] == "application/vnd.google-apps.spreadsheet") {
            $spreadsheets[ $file['id'] ] = $file['name'];
        }
    }
    foreach ($spreadsheets as $spreadsheetsKey => $spreadsheetsName) {
        $worksheetsReturns = wp_remote_get("https://sheets.googleapis.com/v4/spreadsheets/" . $spreadsheetsKey."/?access_token=" . $token['access_token']);
        if (! is_wp_error($worksheetsReturns)  &&  isset($worksheetsReturns['response']['code']) && $worksheetsReturns['response']['code'] == 200) {
            $worksheetsResponseBody = json_decode($worksheetsReturns['body'], true);
            $sheets = array();
            foreach ($worksheetsResponseBody['sheets'] as $value) {
                $sheets[ $value['properties']['sheetId'] ] = $value['properties']['title'];
            }
            $spreadsheetsWorksheet[ $spreadsheetsKey ] = array( $spreadsheetsName, $sheets );
        } else {
            return array( false,  json_encode($worksheetsReturns) );
        }
    }
    return array( true, $spreadsheetsWorksheet );
}

add_action('wp_ajax_get_google_headers', 'get_google_headers');

add_action('wp_ajax_nopriv_get_google_headers', 'get_google_headers');

function get_google_headers()
{
    $sheeID = $_POST['google_sheet_id'];
    $SpreadsheetID  = sanitize_text_field($sheeID);
    $google_token   = get_option('wcgss_google_token', false);
    $columnTitle    = wcgss_columnTitle($SpreadsheetID, $google_token);
    $columnsTitles = json_encode($columnTitle, true);
    $columnhtml = '';
    foreach ($columnTitle as $key=>$title) {
        $columnhtml .= '<option value="'.$title.'">'.$title.'</option>';
    }
    $columnTitles = '';
    $load_html = '<th><label for="wcgss-product_identifier">SKU (Product Identifier)</label></th>
		<td><select id="product_identifier" class="product_identifier_dbsave" name="product_identifier">
		<option value="select" selected disabled hidden>Select an Identifier</option>
                '.$columnhtml.'
		</select></td>';

    $qty_html = '<th><label for="wcgss-qty">Qty</label></th>
		<td><select id="qty" class="qty_dbsave" name="qty">
		<option value="select" selected disabled hidden>Select an Qty</option>
                '.$columnhtml.'
		</select></td>';

    $map_headers = '<th scope="row"><label for="wcgss-credentials">Product Identifiers</label></th><th scope="row"><label for="wcgss-credentials">Spreadsheet Headers</label></th>';


    $siteUrl = get_site_url();
    $data = array(
            'load_html' => $load_html,
	    'qty_html' => $qty_html,
            'map_headers' => $map_headers,	    
            'json' => $columnsTitles,
        );
    echo wp_send_json($data);
    wp_die();
}

add_action('wp_ajax_get_sheet_values', 'get_sheet_values');

add_action('wp_ajax_nopriv_get_sheet_values', 'get_sheet_values');

function get_sheet_values()
{
    $sheeID = get_option('google_sheet_id');
    $google_qty = get_option('google_qty');
    $google_product_identifier = get_option('google_product_identifier');
    $SpreadsheetID  = sanitize_text_field($sheeID);
    $google_token   = get_option('wcgss_google_token', false);
    print_r($google_token);
    $event = new Event_Controller();
    $inventoryUpdate = $event->update_inventory($SpreadsheetID, $google_token, $google_qty, $google_product_identifier);
    echo wp_send_json($inventoryUpdate);
    wp_die();
}

add_action('wp_ajax_get_google_order_headers', 'get_google_order_headers');

add_action('wp_ajax_nopriv_get_google_order_headers', 'get_google_order_headers');

function get_google_order_headers()
{
    $sheeID = $_POST['google_sheet_id'];
    $SpreadsheetID  = sanitize_text_field($sheeID);
    $google_token   = get_option('wcgss_google_token', false);
    $columnTitle    = wcgss_columnTitle($SpreadsheetID, $google_token);
    $columnsTitles = json_encode($columnTitle, true);
    $orderAttribute = array('order_id','item_details','billing_first_name','billing_last_name','billing_company','billing_phone','billing_address_1','billing_address_2','billing_postcode','billing_city','billing_state','billing_country','shipping_first_name','shipping_last_name','shipping_company','shipping_phone','shipping_address_1','shipping_address_2','shipping_postcode','shipping_city','shipping_state','shipping_country','shipment_method','order_total','sub_total','customer_name','customer_email','payment_method','order_date','status');

    $orderAttributes = '';
    foreach ($orderAttribute as $attribute) {
        $orderAttributes .= '<option value="'.$attribute.'">'.$attribute.'</option>';
    }

    $columnhtml = '';
    foreach ($columnTitle as $key=>$title) {
        $columnhtml .= '<option value="'.$title.'">'.$title.'</option>';
    }
    $columnTitles = '';
    $load_html = '';
    $val = 1;
    foreach ($columnTitle as $key=>$title) {
        $load_html .= '<tr id="bind_attribute'.$key.'"><td><select id="woo_order_attribute'.$key.' removeWooAttribute" class="product_identifier_dbsave_woo woo_order_attribute'.$val.'" name="woo_order_attribute'.$key.'" onchange="removeOrderWooAttribute('.$val.');"><option value="select" selected disabled hidden>Select an woocommerce Order Header</option>'.$orderAttributes.'</select></td>
		<td><select id="sheet_header'.$key.'" class="product_identifier_dbsave_google google_order_attribute'.$val.'" name="sheet_header'.$key.'" onchange="addNewHeader(this,'."'".$key."'".');">
		<option value="select" selected disabled hidden>Select an SpreadSheet Header</option>
		'.$columnhtml.'
		<option value="new_header">Add New Header</option>
		</select></td><td><div id="bind_new_header_'.$key.'"></div></td></tr>';
        $val++;
    }

    $map_headers = '<th scope="row"><label for="wcgss-credentials">Order Identifiers</label></th><th scope="row"><label for="wcgss-credentials">Spreadsheet Headers</label></th>';

    $data = array(
            'load_html' => $load_html,
            'map_headers' => $map_headers,
    );
    
    echo wp_send_json($data);
    wp_die();
}

add_action('wp_ajax_get_google_customer_headers', 'get_google_customer_headers');

add_action('wp_ajax_nopriv_get_google_customer_headers', 'get_google_customer_headers');

function get_google_customer_headers()
{
    $sheeID = $_POST['google_sheet_id'];
    $SpreadsheetID  = sanitize_text_field($sheeID);
    $google_token   = get_option('wcgss_google_token', false);
    $columnTitle    = wcgss_columnTitle($SpreadsheetID, $google_token);
    $columnsTitles = json_encode($columnTitle, true);
    $orderAttribute = array('user_name','first_name','last_name','display_name','email','billing_first_name','billing_last_name','billing_company','billing_phone','billing_address_1','billing_address_2','billing_postcode','billing_city','billing_state','billing_country','shipping_first_name','shipping_last_name','shipping_company','shipping_phone','shipping_address_1','shipping_address_2','shipping_postcode','shipping_city','shipping_state','shipping_country');
    $google_customer_mapping = get_option('google_customer_mapping');
    if ($google_customer_mapping == '') {
        $orderAttributes = '';
        foreach ($orderAttribute as $attribute) {
            $orderAttributes .= '<option value="'.$attribute.'">'.$attribute.'</option>';
        }

        $columnhtml = '';
        foreach ($columnTitle as $key=>$title) {
            $columnhtml .= '<option value="'.$title.'">'.$title.'</option>';
        }
    } else {
        $google_customer_mapping1 = json_decode($google_customer_mapping, true);
        $orderAttributes = '';
        foreach ($orderAttribute as $attribute) {
            $orderAttributes .= '<option value="'.$attribute.'">'.$attribute.'</option>';
        }

        $columnhtml = '';
        foreach ($columnTitle as $key=>$title) {
            $columnhtml .= '<option value="'.$title.'">'.$title.'</option>';
        }
    }
    $columnTitles = '';
    $load_html = '';
    $val = 1;
    foreach ($columnTitle as $key=>$title) {
        $load_html .= '<tr id="bind_attribute'.$key.'"><td><select id="woo_customer_attribute'.$key.'" class="product_identifier_dbsave_woo_customer woo_customer_attribute'.$val.'" name="woo_customer_attribute'.$key.'" onchange="removeCustomerWooAttribute('.$val.');"><option value="select" selected disabled hidden>Select an woocommerce Order Header</option>'.$orderAttributes.'</select></td>
			<td><select id="sheet_customer_header'.$key.'" class="product_identifier_dbsave_google_customer google_customer_attribute'.$val.'" name="sheet_customer_header'.$key.'" onchange="removeCustomerGoogleAttribute('.$val.');">
			<option value="select" selected disabled hidden>Select an SpreadSheet Header</option>
			'.$columnhtml.'
			</select></td></tr>';
        $val++;
    }

        $map_headers = '<th scope="row"><label for="wcgss-credentials">Customer Identifiers</label></th><th scope="row"><label for="wcgss-credentials">Spreadsheet Headers</label></th>';

    $data = array(
            'load_html' => $load_html,
            'map_headers' => $map_headers,
    );

    echo wp_send_json($data);
    wp_die();
}
function wcgss_columnTitle($spreadsheets_id = '', $token = [])
{
    $request = wp_remote_get('https://sheets.googleapis.com/v4/spreadsheets/'. $spreadsheets_id . '/values/Sheet1!A1:YZ1?access_token='. $token['access_token']);

    if (is_wp_error($request)  or  ! isset($request['response']['code']) or $request['response']['code'] != 200) {
        return array( false, json_encode($request) );
    }


    $responseBody = json_decode($request['body'], true);

    if (!isset($responseBody['values'][0])) {
        return array( true, array( "A"=>"","B"=>"","C"=>"","D"=>"","E"=>"","F"=>"","G"=>"","H"=>"","I"=>"","J"=>"","K"=>"","L"=>"","M"=>"","N"=>"","O"=>"","P"=>"","Q"=>"","R"=>"","S"=>"","T"=>"","U"=>"","V"=>"","W"=>"","X"=>"","Y"=>"","Z"=>"" ) );
    }

    $key_array = array();
    for ($i = "A"; $i < 'ZZ' ; $i++) {
        array_push($key_array, $i);
    }
    $columnKeyTitle  = array_combine(array_slice($key_array, 0, count($responseBody['values'][0])), $responseBody['values'][0]);

    return$columnKeyTitle;
}

function wcgss_column($spreadsheets_id = '', $token = [])
{

    $request = wp_remote_get('https://sheets.googleapis.com/v4/spreadsheets/'. $spreadsheets_id . '/values/Sheet1!A1:Z100?access_token='. $token['access_token']);

    $responseBody = json_decode($request['body'], true);

    return $responseBody['values'];
}

function insert_header($spreadsheets_id = '', $token = [], $column, $columnHeaderName)
{
	
$curl = curl_init();

curl_setopt_array($curl, array(
  CURLOPT_URL => "https://sheets.googleapis.com/v4/spreadsheets/".$spreadsheets_id."/values/Sheet1!".$column."1:append?valueInputOption=USER_ENTERED",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => '{"values":[["'.$columnHeaderName.'"]]}',
  CURLOPT_HTTPHEADER => array(
    "accept: application/json",
    "authorization: Bearer ".$token['access_token']."",
    "cache-control: no-cache",
    "content-type: application/json",
    "postman-token: 0efa3e34-eca6-5279-3fec-80af4bdfadba"
  ),
));

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

return $response;

}

add_action('woocommerce_new_order', 'order_sync_backend', 111, 1);
function order_sync_backend($order_id)
{
    $event = new Event_Controller();
    $user_ID = get_current_user_id();
    $checkUserRole = $event->checkUserRole($user_ID);
    if ($checkUserRole == true) {
        $order = wc_get_order($order_id);
        $google_order_sheetid   = get_option('google_order_sheetid', false);
        $orderDetail = $event->get_order($order_id, $google_order_sheetid);
        $note = __("wcgss_notes=".$orderDetail);
        $order->add_order_note($note);
        return $orderDetail;
    }
}

add_action('woocommerce_thankyou', 'order_synz_google', 111, 1);
function order_synz_google($order_id)
{
    $google_order_sheetid   = get_option('google_order_sheetid', false);
    $event = new Event_Controller();
    $orderDetail = $event->get_order($order_id, $google_order_sheetid);
    $order = wc_get_order($order_id);
    $note = __("wcgss_notes=".$orderDetail);
    $order->add_order_note($note);
    return $orderDetail;
}

function customer_created($customer_id)
{
    $google_customer_sheetid   = get_option('google_customer_sheetid', false);
    $event = new Event_Controller();
    $customerDetail = $event->get_customer($customer_id, $google_customer_sheetid);
    return $customerDetail;
}
add_action('woocommerce_created_customer', 'customer_created');

add_action('user_register', 'user_registeration');

function user_registeration($customer_id)
{
    $event = new Event_Controller();
    $user_ID = get_current_user_id();
    $checkUserRole = $event->checkUserRole($user_ID);
    if ($checkUserRole == true) {
        $google_customer_sheetid   = get_option('google_customer_sheetid', false);
        $customerDetail = $event->get_customer($customer_id, $google_customer_sheetid);
        return $customerDetail;
    }
}

function action_woocommerce_order_status_changed($this_get_id, $this_status_transition_from, $this_status_transition_to, $instance)
{
    $order_id = $this_get_id;
    $event = new Event_Controller();
    $customerDetail = $event->get_order_notes($order_id, $this_status_transition_to);
    return $customerDetail;
}
add_action('woocommerce_order_status_changed', 'action_woocommerce_order_status_changed', 10, 4);

add_filter('cron_schedules', 'wcgss_inventory_update_cron');
function wcgss_inventory_update_cron($schedules)
{
    $schedules['daily'] = array(
        'display'   => __('Schedule as config', 'textdomain')
    );
    return $schedules;
}

if (! wp_next_scheduled('wcgss_inventory_update_cron')) {
    $inventory = get_option('inventory_schedule_chkbox');
    $inventory_array = json_decode($inventory, true);

    if ($inventory != '') {
        if ($inventory_array['inventory_frequency'] == 'daily') {
            $inventory_ex_hours = $inventory_array['inventory_ex_hours'];
            $minnutes_interval = $inventory_array['inventory_ex_minutes'];
            $current_date = date('Y-m-d');
            $schedule_date = $current_date.' '.$inventory_ex_hours.':'.$minnutes_interval.'';
            $run_date = date('Y-m-d H:i:s', strtotime($schedule_date));
        }
        if ($inventory_array['inventory_frequency'] == 'weekly') {
            $inventory_every = $inventory_array['inventory_every'];
            $inventory_ex_hours_week = $inventory_array['inventory_ex_hours_week'];
            $minnutes_interval_week = $inventory_array['inventory_ex_minutes_week'];
            $week_count = $inventory_every * 7;
            $current_date = date('Y-m-d');
            $string_current_date = strtotime($current_date);
            $string_cal_date = strtotime("+".$week_count." day", $string_current_date);
            $week_run_date = date('Y-m-d', $string_cal_date);
            $week_schedule_date = $week_run_date.' '.$inventory_ex_hours_week.':'.$minnutes_interval_week.'';
            $run_date = date('Y-m-d H:i:s', strtotime($week_schedule_date));
        }
        if ($inventory_array['inventory_frequency'] == 'once') {
            $inventory_dat = $inventory_array['inventory_dat'];
            $inventory_hours = $inventory_array['inventory_hours'];
            $inventory_minutes = $inventory_array['inventory_minutes'];
            $schedule_date = $inventory_dat.' '.$inventory_hours.':'.$inventory_minutes.'';
            $run_date = date('Y-m-d H:i:s', strtotime($schedule_date));
        }
        if ($inventory_array['inventory_frequency'] != 'once') {
            wp_schedule_event(strtotime($run_date), 'daily', 'wcgss_inventory_update_cron');
        } else {
            wp_schedule_single_event(strtotime($run_date), 'wcgss_inventory_update_cron');
        }
    }
}

add_action('wcgss_inventory_update_cron', 'update_product_qty_by_sku');
function update_product_qty_by_sku()
{
    get_sheet_values();
}

add_filter( 'bulk_actions-edit-product', 'instant_sync_product_bulk_actions' );
function instant_sync_product_bulk_actions( $bulk_actions ) {
    $bulk_actions['instant_sync'] = 'Instant sync';
    return $bulk_actions;
}

add_action( 'admin_action_instant_sync', 'get_bulk_products' );
function get_bulk_products() {
    if( !isset( $_REQUEST['post'] ) && !is_array( $_REQUEST['post'] ) )
	    return;
    wcgss_GoogleSpreadsheets();
    $sheeID = get_option('google_sheet_id');
    $SpreadsheetID  = sanitize_text_field($sheeID);
    $google_token   = get_option('wcgss_google_token', true);
    $event = new Event_Controller();
    foreach( $_REQUEST['post'] as $product_id ) {
	    $sku = get_post_meta( $product_id, '_sku', true );
	    $inventoryUpdate = $event->update_inventory_listpage($SpreadsheetID, $google_token,$sku);
    }

    $location = add_query_arg( array(
                'post_type' => 'product',
                'instant_sync' => 1,
                'changed' => count( $_REQUEST['post'] ),
                'ids' => join( $_REQUEST['post'], ',' ),
                'post_status' => 'all'
        ), 'edit.php' );
    wp_redirect( admin_url( $location ) );
    exit;

}

add_filter( 'bulk_actions-edit-shop_order', 'instant_sync_orders_bulk_actions' );
function instant_sync_orders_bulk_actions( $bulk_actions ) {
    $bulk_actions['instant_sync_order'] = 'Instant sync Orders';
    return $bulk_actions;
}


add_action( 'admin_action_instant_sync_order', 'get_bulk_orders' );
function get_bulk_orders() {
    if( !isset( $_REQUEST['post'] ) && !is_array( $_REQUEST['post'] ) )
            return;
    wcgss_GoogleSpreadsheets();
    foreach( $_REQUEST['post'] as $order_id ) {
	    order_synz_google($order_id);
    }

	$location = add_query_arg( array(
    		'post_type' => 'shop_order',
		'instant_sync_order' => 1, 
		'changed' => count( $_REQUEST['post'] ), 
		'ids' => join( $_REQUEST['post'], ',' ),
		'post_status' => 'all'
	), 'edit.php' );

	wp_redirect( admin_url( $location ) );
	exit;    
}

add_action('admin_notices', 'order_status_notices');

function order_status_notices() {

	global $pagenow, $typenow;

	if( $typenow == 'shop_order'
	 && $pagenow == 'edit.php'
	 && isset( $_REQUEST['instant_sync_order'] ) ) {
		$message = 'Order updated to google sheet.';
		echo "<div class=\"updated\"><p>{$message}</p></div>";
	}
	
	if( $typenow == 'product'
         && $pagenow == 'edit.php'
         && isset( $_REQUEST['instant_sync'] ) ) {
                $message = 'Product updated to google sheet.';
                echo "<div class=\"updated\"><p>{$message}</p></div>";
        }	
}

function wc_logs_datatables() {

    ob_start(); ?>

    <table id="wc_logstable" class="table table-striped table-hover">
    <thead>
        <tr>
            <th>Module Name</th>
	    <th>Response</th>
            <th>Date/Time</th>
        </tr>
    </thead>
    </table>
    <?php return ob_get_clean();
}


add_shortcode ('wc_logs_datatables', 'wc_logs_datatables');

add_action('wp_ajax_wc_logs_datatables', 'wc_datatables_server_side_callback');
add_action('wp_ajax_nopriv_wc_logs_datatables', 'wc_datatables_server_side_callback');


function wc_datatables_server_side_callback() {

  header("Content-Type: application/json");
  global $wpdb;
  $table = $wpdb->prefix . 'wcgss_logs';
  $result = $wpdb->get_results("SELECT * FROM ".$table." order by id desc");
  $totalData = count($result);

  if ( count($result) != 0 ) {

          foreach ($result as $post) {
                  $module = $post->module;
		  $response = $post->response;
		  $date = $post->date;

      $nestedData = array();
      $nestedData[] = $module;
      $nestedData[] = $response;
      $nestedData[] = $date;      

      $data[] = $nestedData;

    }
    wp_reset_query();
    $json_data = array(
      "recordsTotal" => intval($totalData),
      "recordsFiltered" => intval($totalData),
      "data" => $data
    );

    echo json_encode($json_data);

  } else {

    $json_data = array(
      "data" => array()
    );

    echo json_encode($json_data);
  }

  wp_die();

}


add_action('wp_ajax_get_google_orderitem_headers', 'get_google_orderitem_headers');

add_action('wp_ajax_nopriv_get_google_orderitem_headers', 'get_google_orderitem_headers');

function get_google_orderitem_headers()
{
    $sheeID = $_POST['google_sheet_orderitem_id'];
    $SpreadsheetID  = sanitize_text_field($sheeID);
    $google_token   = get_option('wcgss_google_token', false);
    $columnTitle    = wcgss_columnTitle($SpreadsheetID, $google_token);
    $columnsTitles = json_encode($columnTitle, true);
    $orderAttribute = array('order_id','item_details','billing_first_name','billing_last_name','billing_company','billing_phone','billing_address_1','billing_address_2','billing_postcode','billing_city','billing_state','billing_country','shipping_first_name','shipping_last_name','shipping_company','shipping_phone','shipping_address_1','shipping_address_2','shipping_postcode','shipping_city','shipping_state','shipping_country','shipment_method','order_total','sub_total','customer_name','customer_email','payment_method','order_date','status');

    $orderAttributes = '';
    foreach ($orderAttribute as $attribute) {
        $orderAttributes .= '<option value="'.$attribute.'">'.$attribute.'</option>';
    }

    $columnhtml = '';
    foreach ($columnTitle as $key=>$title) {
        $columnhtml .= '<option value="'.$title.'">'.$title.'</option>';
    }
    $columnTitles = '';
    $load_html = '';
    $val = 1;
    foreach ($columnTitle as $key=>$title) {
        $load_html .= '<tr id="bind_attribute'.$key.'"><td><select id="woo_order_attribute'.$key.' removeWooAttribute" class="product_identifier_dbsave_woo woo_order_attribute'.$val.'" name="woo_order_attribute'.$key.'" onchange="removeOrderWooAttribute('.$val.');"><option value="select" selected disabled hidden>Select an woocommerce Order Header</option>'.$orderAttributes.'</select></td>
                <td><select id="sheet_header'.$key.'" class="product_identifier_dbsave_google google_order_attribute'.$val.'" name="sheet_header'.$key.'" onchange="addNewHeader(this,'."'".$key."'".');">
                <option value="select" selected disabled hidden>Select an SpreadSheet Header</option>
                '.$columnhtml.'
                <option value="new_header">Add New Header</option>
                </select></td><td><div id="bind_new_header_'.$key.'"></div></td></tr>';
        $val++;
    }

    $map_headers = '<th scope="row"><label for="wcgss-credentials">Order Identifiers</label></th><th scope="row"><label for="wcgss-credentials">Spreadsheet Headers</label></th>';

    $data = array(
            'load_html' => $load_html,
            'map_headers' => $map_headers,
    );

    echo wp_send_json($data);
    wp_die();
}
